function F = score_pd(x)
% score = score_pd( pos_gain vel_gain )
% Evaluate a PD controller for KDC assignment 1
global time_step
global duration
global n_time_steps
global data_array
global store_data
global moment_of_inertia
global angle_desired
global mass
global length
global g
global viscous_friction
global state_penalty
time = 0;
angle = 0;
angular_velocity = 0;
acc = 0;
torque = 0;
score = 0;
kp = x(1);
kv = x(2);
for i = 1:n_time_steps,
 % store previous sample
 if store_data > 0 
  data_array(i,1) = time;
  data_array(i,2) = angle;
  data_array(i,3) = angular_velocity;
  data_array(i,4) = acc;
  data_array(i,5) = torque;
  data_array(i,6) = score;
  data_array(i,7) = angle_desired;
  data_array(i,8) = 0;
  data_array(i,9) = 0;
 end
 time = i*time_step;
 torque = kp*(angle_desired - angle) - kv*angular_velocity;
 acc = (torque - viscous_friction*angular_velocity - mass*g*length/2*sin(angle))/moment_of_inertia;
 new_angular_velocity = angular_velocity + acc*time_step;
 angle = angle + (angular_velocity + new_angular_velocity)*time_step/2;
 angular_velocity = new_angular_velocity;
 score = score + torque*torque*time_step + state_penalty*time_step*(angle - angle_desired)*(angle - angle_desired);
end
F = score;
