function F = score_traj1(x)
% score = score_traj1( duration )
% Evaluate a trajectory for KDC assignment 1
% optimize movement_duration which controls a quintic spline (quintic.m
global time_step
global duration
global n_time_steps
global data_array
global store_data
global moment_of_inertia
global angle_desired
global mass
global length
global g
global viscous_friction
global state_penalty
global target
time = 0;
angle = 0;
angular_velocity = 0;
acc = 0;
torque = 0;
score = 0;
angle_desired = 0;
angular_velocity_desired = 0;
acc_desired = 0;
kp = 5;
kv = 2;
movement_duration = x(1);
for i = 1:n_time_steps,
 % store previous sample
 if store_data > 0 
  data_array(i,1) = time;
  data_array(i,2) = angle;
  data_array(i,3) = angular_velocity;
  data_array(i,4) = acc;
  data_array(i,5) = torque;
  data_array(i,6) = score;
  data_array(i,7) = angle_desired;
  data_array(i,8) = angular_velocity_desired;
  data_array(i,9) = acc_desired;
 end
 time = i*time_step;
 [angle_desired angular_velocity_desired acc_desired] = quintic( time, movement_duration, target );
 torque = kp*(angle_desired - angle) + kv*(angular_velocity_desired - angular_velocity) + moment_of_inertia*acc_desired + viscous_friction*angular_velocity + mass*g*length/2*sin(angle);
 acc = (torque - viscous_friction*angular_velocity - mass*g*length/2*sin(angle))/moment_of_inertia;
 new_angular_velocity = angular_velocity + acc*time_step;
 angle = angle + (angular_velocity + new_angular_velocity)*time_step/2;
 angular_velocity = new_angular_velocity;
 score = score + torque*torque*time_step + state_penalty*time_step*(angle - angle_desired)*(angle - angle_desired);
end
F = score;

% Provide entertainment
fprintf( 1, '%g %g\n', movement_duration, score );
ii = 1:n_time_steps;
plot(ii,data_array(ii,2),'b',ii,data_array(ii,7),'r')
drawnow
